/*
 * Helper.java
 *
 * Author: Shahrzad Jahangirian
 *
 * I created this class as an utility class.
 *
 */

package shaz;

/**
 *
 * @author Shahrzad Jahangirian
 */

import java.awt.*;
import java.lang.*;
import javax.swing.*;
import java.lang.Object;
import java.text.*;

public class Helper {

  public Helper() {
  }

  // this method get a frame object and center align on screen
  public void centerFrame(JFrame anObject) {
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    int screenWidth = screenSize.width;
    int screenHeight = screenSize.height;
    Dimension frameSize = anObject.getSize();
    int x = (screenWidth - frameSize.width) / 2;
    int y = (screenHeight - frameSize.height) / 2;
    anObject.setLocation(x, y);
  }

  public boolean isDouble(String number) {
    // this method get a string and validate it if it is generic double or not.
    boolean isDouble = true;

    if (number.equals("") == false) {
      try {
        double balance = Double.valueOf(number).doubleValue();
      }
      catch (NumberFormatException e) {
        isDouble = false;
      }
    }
    return isDouble;
  }

  public int isDoubleNumber(String number) {
    /** this method get a string and validate it if it is generic double or not.
     *  it returns 0 if the string is a number otherwise 1
     */
    int isDouble = 0;

    if (number.equals("") == false) {
      try {
        double balance = Double.valueOf(number).doubleValue();
      }
      catch (NumberFormatException e) {
        isDouble = 1;
      }
    }
    return isDouble;
  }

  public String charToString(char[] item) {
    String str = new String();

    for (int i = 0; i < item.length; i++) {
      str = str + item[i];
    }
    return str;
  }

  public String formatDouble(double number, String fmt) {
    // user must enter a decimal format such as 0.00 or 0.000,000
    DecimalFormat df = new DecimalFormat(fmt);
    return df.format(number);
  }

  public double roundDouble(double d, int places) {
    return Math.round(d * Math.pow(10, (double) places)) / Math.pow(10,
        (double) places);
  }

  public int isEven(int num) {
    int result = num / 2;
    return result;
  }

  public boolean isNumber(String str) {
    boolean valid = false;
    try {
      Integer.parseInt(str);
      valid = true;
    }
    catch (Exception e) {
      valid = false;
    }
    return valid;
  }

  public boolean isValidRange(String str,int num1,int num2) {
    // this method validate a string to see is it a number in a valid range
    // between num1 and num2
    boolean valid = isNumber(str);
    if (valid == true) {
      try {
        int num = Integer.valueOf(str).intValue();
        if ( (num >= num1) && (num <= num2)) {
          valid = true;
        }
        else {
          valid = false;
        }
      }
      catch (Exception e) {
        valid = false;
      }
    }
    return valid;
  }

  public boolean isValidPrice(String str){
    boolean valid = false;
     try {
       Integer.parseInt(str);
       valid = true;
     }
     catch (Exception e) {
       try{
         Double.parseDouble(str);
         valid = true;
       }
       catch (Exception ex){
         valid = false;
       }
     }
     return valid;
  }

}
