/*
 Class: MetaData
 Author: Shahrzad Jahangirian
 Date: March 25, 2014

 This class establish a connection to MySql Database Managment System on your Computer
 using JDBC and then create a database named as
 BOLDER and then create PARTICIPANT, RACE, and WINNER Tables. It needs to be run only once to
 connect to MySql database using username and password at
 jdbc:mysql://localhost?user=YourMysqlUsername&password=YourMysqlPassword
 then it creates the Database, and its Tables.
 */

import java.sql.*;

public class MetaData {

    public static void main(String args[]) {

        String url =
                "jdbc:mysql://localhost?user=root&password=MySqlPass22";
        Connection con;
        String createDatabase = new String("create database BOLDER");
        String useDatabase = new String("use BOLDER");
        String participantTable = new String();
        String raceTable = new String();
        String winnerTable = new String();
        Statement stmt;

        participantTable = "CREATE TABLE PARTICIPANT"
                + "(participantId INT NOT NULL, "
                + "ssn VARCHAR(35) NOT NULL UNIQUE, "
                + "name VARCHAR(100), "
                + "surname VARCHAR(150), "
                + "nickname VARCHAR(100), "
                + "birthDate VARCHAR(10),"
                + "age INTEGER,"
                + "pr VARCHAR(20),"
                + "address1 VARCHAR(200),"
                + "address2 VARCHAR(200),"
                + "city VARCHAR(100),"
                + "state VARCHAR(100),"
                + "zip VARCHAR(100),"
                + "country VARCHAR(25),"
                + "email VARCHAR(200),"
                + "gender VARCHAR(10),"
                + "mobile VARCHAR(35),"
                + "phone VARCHAR(50),"
                + "emergencyPhone VARCHAR(50),"
                + "raceType VARCHAR(20),"
                + "raceId INTEGER NOT NULL,"
                + "PRIMARY KEY(participantId))";                 

        raceTable = "CREATE TABLE RACE"
                + "(raceId INT NOT NULL UNIQUE, "
                + "raceDate VARCHAR(10), "
                + "raceTime VARCHAR(20), "
                + "raceName VARCHAR(300), "
                + "PRIMARY KEY(raceId))";

        winnerTable = "CREATE TABLE WINNER"
                + "(raceid INTEGER NOT NULL UNIQUE, "
                + "ssn VARCHAR(35), "
                + "master BOOLEAN, "
                + "PRIMARY KEY(raceId, ssn))";


        try {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        } catch (java.lang.ClassNotFoundException e) {
            System.err.println("ClassNotFoundException: " + e.getMessage());
        }

        try {
            con = DriverManager.getConnection(url);
            stmt = con.createStatement();
            stmt.execute(createDatabase);
            stmt.execute(useDatabase);
            stmt.execute(raceTable);
            stmt.execute(participantTable);
            stmt.execute(winnerTable);        
            stmt.close();
            con.close();
        } catch (SQLException ex) {
            System.err.println("SQLException: " + ex.getMessage());
        }
    }
}
