/*
 Class: Participant
 Author: Shahrzad Jahangirian
 Date: March 24, 2014
 Description: A class for Bolder Race Participants
 */
package PDpkg;

import java.util.*;
import java.text.*;

public class Participant {
  private int id;
  private String ssn = new String();
  private String name = new String();
  private String surname = new String();
  private String nickname = new String();
  private int[] birthDate = new int[3]; //0=year, 1=month, 2=day
  private Calendar todaysDate;
  private int age;
  private String pr = new String();
  private String address1 = new String();
  private String address2 = new String();
  private String city = new String();
  private String state = new String();
  private String zip = new String();
  private String country = new String();
  private String gender = new String();
  private String email = new String();
  private String phone = new String();
  private String emergPhone = new String();
  private String mobile = new String();
  private int raceId;
  private String raceType = new String();

  public Participant() {

  }

  // Calculate Age in years
  public int calculateAge() {
    todaysDate = Calendar.getInstance();
    todaysDate.setTime(new java.util.Date());
    age = todaysDate.get(Calendar.YEAR) - birthDate[0];
    return age;
  }

  public int calculateAge(int birthYear) {
   todaysDate = Calendar.getInstance();
   todaysDate.setTime(new java.util.Date());
   age = todaysDate.get(Calendar.YEAR) - birthYear;
   return age;
 }


  public int getId() {
    return id;
  }

  public String getSsn() {
    return ssn;
  }

  public String getName() {
    return name;
  }

  public String getSurname() {
    return surname;
  }

  public String getNickname() {
    return nickname;
  }

  public String getBirthDate() {
    String result = String.valueOf(birthDate[0]) + "/" +
        String.valueOf(birthDate[1]) + "/" + String.valueOf(birthDate[2]);
    return result;
  }

  public int getAge() {
    return age;
  }

  public String getPr() {
    return pr;
  }

  public String getAddress1() {
    return address1;
  }

  public String getAddress2() {
    return address2;
  }

  public String getCity() {
    return city;
  }

  public String getState() {
    return state;
  }

  public String getZip() {
    return zip;
  }

  public String getCountry() {
    return country;
  }

  public String getGender() {
    return gender;
  }

  public String getEmail() {
    return email;
  }

  public String getPhone() {
    return phone;
  }

  public String getEmergPhone() {
    return emergPhone;
  }

  public String getMobile() {
    return mobile;
  }

  public int getRaceId() {
    return raceId;
  }

  public String getRaceType() {
    return raceType;
  }

  public void setId(int id) {
   this.id = id;
 }

  public void setSsn(String ssn) {
    this.ssn = ssn;
  }

  public void setName(String name) {
    this.name = name;
  }

  public void setSurname(String surname) {
    this.surname = surname;
  }

  public void setNickname(String nickname) {
    this.nickname = nickname;
  }

  public void setBirthDate(String bDate) {

   String[] result = bDate.split("\\/");
   birthDate[0] = Integer.parseInt(result[2]);
   birthDate[1] = Integer.parseInt(result[1]);
   birthDate[2] = Integer.parseInt(result[0]);
 }

  public void setAge(int age) {
    this.age = age;
  }

  public void setPr(String pr) {
    this.pr = pr;
  }

  public void setAddress1(String address1) {
    this.address1 = address1;
  }

  public void setAddress2(String address2) {
    this.address2 = address2;
  }

  public void setCity(String city) {
    this.city = city;
  }

  public void setState(String state) {
    this.state = state;
  }

  public void setZip(String zip) {
    this.zip = zip;
  }

  public void setCountry(String country) {
    this.country = country;
  }

  public void setGender(String gender) {
    this.gender = gender;
  }

  public void setEmail(String email) {
    this.email = email;
  }

  public void setPhone(String phone) {
    this.phone = phone;
  }

  public void setEmergPhone(String emergPhone) {
    this.emergPhone = emergPhone;
  }

  public void setMobile(String mobile) {
    this.mobile = mobile;
  }

  public void setRaceId(int raceId) {
    this.raceId = raceId;
  }

  public void setRaceType(String raceType) {
    this.raceType = raceType;
  }

}
