/*
 Class: Race
 Author: Shahrzad Jahangirian
 Date: May 2, 2014
 Description: A problem domain class for processing Races
 */
package PDpkg;
import java.util.*;
import java.text.*;
import PDpkg.RaceInfo;
import DBpkg.RaceDB;

public class Race{

 private RaceDB raceDb = new RaceDB();
 private String[] raceIds;

  public Race(){

  }
  
  public boolean isRaceEmpty(){
      return raceDb.isRaceEmpty();
  }
  
  public String[] getAllRacesIds(){
      raceDb = new RaceDB();
      ArrayList raceLst = new ArrayList();
      raceLst = raceDb.getAllRaces();
      raceIds = new String[raceLst.size()];
      for(int i=0; i< raceLst.size(); i++){
          raceIds[i]=new String(String.valueOf(((RaceInfo)raceLst.get(i)).getRaceId()));
      }
      return raceIds;
  }
  
  public RaceInfo validateRaceId(int raceId){
      RaceInfo raceRecord = new RaceInfo();
      boolean duplicateRaceId = false;
      duplicateRaceId = raceDb.isRaceIdDuplicate(raceId);
      if (duplicateRaceId == true){    
          raceRecord = raceDb.getRecord();
      } 
      return raceRecord;
  }

  public boolean addRace(RaceInfo raceRecord){
    boolean ok = false;   
    ok = raceDb.saveRace(raceRecord);
    return ok;
  }
  
  public boolean updateRace(RaceInfo raceRecord){
    boolean ok = false;    
    ok = raceDb.updateRace(raceRecord);
    return ok;
  }
  
  public boolean deleteRace(int raceId){
    boolean ok = false;    
    ok = raceDb.deleteRace(raceId);
    return ok;
  }
  
   public boolean isRaceInWinner(){
      return raceDb.isRaceInWinner();
  }

}
