/*
 Class: RegisterUI
 Author: Shahrzad Jahangirian
 Date: March 20, 2014
 Description: A data entry screen for register, update, and delete a participant 
 * for Bolder Race.
 */
package GUIpkg;

import javax.swing.*;
import java.awt.*;
import java.awt.*;
import java.awt.Color;
import java.awt.event.*;
import java.util.*;
import java.text.*;

import commonPKG.FormatUI;
import PDpkg.Registration;
import PDpkg.Participant;
import PDpkg.Race;

public class RegisterUI
        extends JFrame {

    private JPanel bodyPanel = new JPanel();
    private JPanel statusBarPanel = new JPanel();
    private JLabel statusBarLabel = new JLabel();
    private JLabel ssnLabel = new JLabel();
    private JLabel nameLabel = new JLabel();
    private JLabel surnameLabel = new JLabel();
    private JLabel nicknameLabel = new JLabel();
    private JLabel birthDateLabel = new JLabel();
    private JLabel ageLabel = new JLabel();
    private JLabel prLabel = new JLabel();
    private JLabel address1Label = new JLabel();
    private JLabel address2Label = new JLabel();
    private JLabel cityLabel = new JLabel();
    private JLabel stateLabel = new JLabel();
    private JLabel zipLabel = new JLabel();
    private JLabel countryLabel = new JLabel();
    private JLabel emailLabel = new JLabel();
    private JLabel genderLabel = new JLabel();
    private JLabel mobileLabel = new JLabel();
    private JLabel phoneLabel = new JLabel();
    private JLabel emergPhoneLabel = new JLabel();
    private JLabel raceTypeLabel = new JLabel();
    private JLabel raceIdLabel = new JLabel();
    private JTextField ssnTextField = new JTextField();
    private JTextField nameTextField = new JTextField();
    private JTextField surnameTextField = new JTextField();
    private JTextField nicknameTextField = new JTextField();
    private JTextField birthDateTextField = new JTextField();
    private JTextField ageTextField = new JTextField();
    private JTextField prTextField = new JTextField();
    private JTextField address1TextField = new JTextField();
    private JTextField address2TextField = new JTextField();
    private JTextField cityTextField = new JTextField();
    private JTextField stateTextField = new JTextField();
    private JTextField zipTextField = new JTextField();
    private JTextField countryTextField = new JTextField();
    private JTextField emailTextField = new JTextField();
    private String[] genderString = {
        "Male", "Female"};
    private JComboBox genderComboBox = new JComboBox(genderString);
    private JTextField mobileTextField = new JTextField();
    private JTextField phoneTextField = new JTextField();
    private JTextField emergPhoneTextField = new JTextField();
    private String[] raceTypeString = {
        "Runner", "Jogger", "JogWalker", "WalkJogger", "Walker", "Wheelchair"};
    private JComboBox raceTypeComboBox = new JComboBox(raceTypeString);
    private String[] raceIdString;
    private JComboBox raceIdComboBox;
    private JButton saveButton = new JButton();
    private JButton clearButton = new JButton();
    private JButton deleteButton = new JButton();
    private JButton updateButton = new JButton();
    private Date calendar;
    private SimpleDateFormat sdf;
    private String dateString = new String();
    private boolean ageFlag = false;
    private FormatUI format = new FormatUI();
    private Registration reg = new Registration();
    private Participant person = new Participant();
    private Participant updatePerson = new Participant();
    private String dupSSN = new String();
    private boolean ssnFocus = false;
    private boolean ssnTyped = false;
    private ImageIcon regIcon = new ImageIcon("icons/register_th.png");
    private Race race = new Race();

    public RegisterUI() {
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    public void jbInit() {

        bodyPanel = format.formatPanel(bodyPanel, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12);
        bodyPanel.setLayout(null);
        statusBarPanel = format.createStatusBar(statusBarPanel, 240, 240, 240, 800,
                25);
        raceIdString = race.getAllRacesIds();
        raceIdComboBox = new JComboBox(raceIdString);
        formatUserInterfaces();
        addListeners();
        addToPanel();
        setActionButtons(true, true, false, false);

        this.setSize(767, 435);
        format.centerFrame(this);
        this.setResizable(false);
        this.getContentPane().setLayout(new BorderLayout());
        this.getContentPane().add(bodyPanel, null);
        this.getContentPane().add(statusBarPanel, BorderLayout.PAGE_END);
        this.getContentPane().setBackground(new Color(250, 250, 250));
        this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        this.setIconImage(regIcon.getImage());
        this.setTitle("Register a Participant");
    }

    public void setActionButtons(boolean saveFlag, boolean clearFlag, boolean delFlag, boolean updateFlag) {
        saveButton.setVisible(saveFlag);
        clearButton.setVisible(clearFlag);
        deleteButton.setVisible(delFlag);
        updateButton.setVisible(updateFlag);
    }

    public void setStatusBar(String msg) {
        statusBarLabel.setText(msg);
    }

    public void formatUserInterfaces() {
        statusBarLabel = format.formatLabel(statusBarLabel,
                "", 1, 1,
                750, 20, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        ssnLabel = format.formatLabel(ssnLabel,
                "Social Security Number", 16, 10,
                150, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        ssnTextField = format.formatTextField(ssnTextField, "", 15,
                30, 175, 25, 255, 255, 255, 96,
                104, 113, "Arial", 0, 12, 0);
        nameLabel = format.formatLabel(nameLabel,
                "First Name", 201, 10,
                150, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        nameTextField = format.formatTextField(nameTextField, "", 200,
                30, 175, 25, 255, 255, 255, 96,
                104, 113, "Arial", 0, 12, 0);
        surnameLabel = format.formatLabel(surnameLabel,
                "Surname", 386, 10,
                150, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        surnameTextField = format.formatTextField(surnameTextField, "", 385,
                30, 175, 25, 255, 255, 255, 96,
                104, 113, "Arial", 0, 12, 0);
        nicknameLabel = format.formatLabel(nicknameLabel,
                "Nickname", 571, 10,
                150, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        nicknameTextField = format.formatTextField(nicknameTextField, "", 570,
                30, 175, 25, 255, 255, 255, 96,
                104, 113, "Arial", 0, 12, 0);
        birthDateLabel = format.formatLabel(birthDateLabel,
                "Birth Date", 16, 70,
                150, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);

        calendar = new GregorianCalendar(TimeZone.getDefault()).getTime();
        sdf = new SimpleDateFormat("d/MM/yyyy");
        dateString = sdf.format(calendar);
        birthDateTextField = format.formatTextField(birthDateTextField, dateString,
                15,
                90, 175, 25, 255, 255, 255, 96,
                104, 113, "Arial", 0, 12, 0);
        ageLabel = format.formatLabel(ageLabel,
                "Age", 201, 70,
                75, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        ageTextField = format.formatTextField(ageTextField, "", 200,
                90, 82, 25, 255, 255, 255, 96,
                104, 113, "Arial", 0, 12, 0);
        genderLabel = format.formatLabel(genderLabel,
                "Gender", 293, 70,
                75, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        genderComboBox = format.formatComboBox(genderComboBox, 292, 91, 83, 25, false, false,
                0, 255, 255, 255, 96, 104, 113,
                "Arial", 0, 12, 3);
        emailLabel = format.formatLabel(emailLabel,
                "Email Address", 386, 70,
                100, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        emailTextField = format.formatTextField(emailTextField, "", 385,
                90, 360, 25, 255, 255, 255, 96,
                104, 113, "Arial", 0, 12, 0);
        address1Label = format.formatLabel(address1Label,
                "Address 1", 16, 130,
                100, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        address1TextField = format.formatTextField(address1TextField, "", 15,
                150, 360, 25, 255, 255, 255, 96,
                104, 113, "Arial", 0, 12, 0);
        address2Label = format.formatLabel(address2Label,
                "Address 2", 386, 130,
                100, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        address2TextField = format.formatTextField(address2TextField, "", 385,
                150, 360, 25, 255, 255, 255, 96,
                104, 113, "Arial", 0, 12, 0);
        cityLabel = format.formatLabel(cityLabel,
                "City", 16, 190,
                150, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        cityTextField = format.formatTextField(cityTextField, "", 15,
                210, 175, 25, 255, 255, 255, 96,
                104, 113, "Arial", 0, 12, 0);
        stateLabel = format.formatLabel(stateLabel,
                "State", 201, 190,
                75, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        stateTextField = format.formatTextField(stateTextField, "", 200,
                210, 82, 25, 255, 255, 255, 96,
                104, 113, "Arial", 0, 12, 0);
        zipLabel = format.formatLabel(zipLabel,
                "Zip Code", 293, 190,
                75, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        zipTextField = format.formatTextField(zipTextField, "", 292,
                210, 83, 25, 255, 255, 255, 96,
                104, 113, "Arial", 0, 12, 0);
        countryLabel = format.formatLabel(countryLabel,
                "Country", 386, 190,
                150, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        countryTextField = format.formatTextField(countryTextField, "", 385,
                210, 175, 25, 255, 255, 255, 96,
                104, 113, "Arial", 0, 12, 0);
        phoneLabel = format.formatLabel(phoneLabel,
                "Phone", 571, 190,
                150, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        phoneTextField = format.formatTextField(phoneTextField, "", 570,
                210, 175, 25, 255, 255, 255, 96,
                104, 113, "Arial", 0, 12, 0);
        emergPhoneLabel = format.formatLabel(emergPhoneLabel,
                "Emergency Phone", 16, 250,
                150, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        emergPhoneTextField = format.formatTextField(emergPhoneTextField, "", 15,
                270, 175, 25, 255, 255, 255,
                96,
                104, 113, "Arial", 0, 12, 0);
        mobileLabel = format.formatLabel(mobileLabel,
                "Mobile Phone", 201, 250,
                150, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        mobileTextField = format.formatTextField(mobileTextField, "", 200,
                270, 175, 25, 255, 255, 255, 96,
                104, 113, "Arial", 0, 12, 0);
        prLabel = format.formatLabel(prLabel,
                "PR", 386, 250,
                75, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        prTextField = format.formatTextField(prTextField, "", 385,
                270, 82, 25, 255, 255, 255, 96,
                104, 113, "Arial", 0, 12, 0);
        raceTypeLabel = format.formatLabel(raceTypeLabel,
                "Race Type", 571, 250,
                75, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        raceTypeComboBox = format.formatComboBox(raceTypeComboBox, 570, 271, 175, 25, false, false,
                0, 255, 255, 255, 96, 104, 113,
                "Arial", 0, 12, 3);
        raceIdLabel = format.formatLabel(raceIdLabel,
                "Race ID", 478, 250,
                75, 17, 240, 240, 240, 96, 104, 113,
                "Arial", 0, 12, SwingConstants.CENTER,
                SwingConstants.LEFT);
        raceIdComboBox = format.formatComboBox(raceIdComboBox, 477, 271, 83, 25, false, false,
                0, 255, 255, 255, 96, 104, 113,
                "Arial", 0, 12, 3);
        saveButton = format.formatButton(saveButton, "Save", 570, 320, 83, 25, 96,
                104, 113, "Arial", 0, 12);
        updateButton = format.formatButton(updateButton, "Update", 570, 320, 83, 25,
                96,
                104, 113, "Arial", 0, 12);
        deleteButton = format.formatButton(deleteButton, "Delete", 478, 320, 83, 25,
                96,
                104, 113, "Arial", 0, 12);
        clearButton = format.formatButton(clearButton, "Clear", 662, 320, 83, 25,
                96,
                104, 113, "Arial", 0, 12);

    }

    public void addListeners() {
        clearButton.addActionListener(new RegisterUI_clearButton_actionAdapter(this));
        saveButton.addActionListener(new RegisterUI_saveButton_actionAdapter(this));
        birthDateTextField.addFocusListener(new RegisterUI_birthDateTextField_focusAdapter(this));
        prTextField.addFocusListener(new RegisterUI_prTextField_focusAdapter(this));
        ssnTextField.addFocusListener(new RegisterUI_ssnTextField_focusAdapter(this));
        ssnTextField.addKeyListener(new RegisterUI_ssnTextField_keyAdapter(this));
        deleteButton.addActionListener(new RegisterUI_deleteButton_actionAdapter(this));
        updateButton.addActionListener(new RegisterUI_updateButton_actionAdapter(this));
    }

    public void addToPanel() {
        statusBarPanel.add(statusBarLabel);
        bodyPanel.add(ssnLabel);
        bodyPanel.add(ssnTextField);
        bodyPanel.add(nameLabel);
        bodyPanel.add(nameTextField);
        bodyPanel.add(surnameLabel);
        bodyPanel.add(surnameTextField);
        bodyPanel.add(nicknameLabel);
        bodyPanel.add(nicknameTextField);
        bodyPanel.add(birthDateLabel);
        bodyPanel.add(birthDateTextField);
        bodyPanel.add(ageLabel);
        bodyPanel.add(ageTextField);
        bodyPanel.add(genderLabel);
        bodyPanel.add(genderComboBox);
        bodyPanel.add(emailLabel);
        bodyPanel.add(emailTextField);
        bodyPanel.add(address1Label);
        bodyPanel.add(address1TextField);
        bodyPanel.add(address2Label);
        bodyPanel.add(address2TextField);
        bodyPanel.add(cityLabel);
        bodyPanel.add(cityTextField);
        bodyPanel.add(stateLabel);
        bodyPanel.add(stateTextField);
        bodyPanel.add(zipLabel);
        bodyPanel.add(zipTextField);
        bodyPanel.add(countryLabel);
        bodyPanel.add(countryTextField);
        bodyPanel.add(phoneLabel);
        bodyPanel.add(phoneTextField);
        bodyPanel.add(emergPhoneLabel);
        bodyPanel.add(emergPhoneTextField);
        bodyPanel.add(mobileLabel);
        bodyPanel.add(mobileTextField);
        bodyPanel.add(prLabel);
        bodyPanel.add(prTextField);
        bodyPanel.add(raceIdLabel);
        bodyPanel.add(raceIdComboBox);
        bodyPanel.add(raceTypeLabel);
        bodyPanel.add(raceTypeComboBox);
        bodyPanel.add(updateButton);
        bodyPanel.add(deleteButton);
        bodyPanel.add(saveButton);
        bodyPanel.add(clearButton);
    }

    void clearButton_actionPerformed(ActionEvent e) {
        clear();
    }

    public void clear() {
        ssnTextField.setText("");
        nameTextField.setText("");
        surnameTextField.setText("");
        nicknameTextField.setText("");
        birthDateTextField.setText(dateString);
        ageTextField.setText("");
        prTextField.setText("");
        address1TextField.setText("");
        address2TextField.setText("");
        cityTextField.setText("");
        stateTextField.setText("");
        zipTextField.setText("");
        countryTextField.setText("");
        emailTextField.setText("");
        genderComboBox.setSelectedIndex(0);
        mobileTextField.setText("");
        phoneTextField.setText("");
        emergPhoneTextField.setText("");
        raceTypeComboBox.setSelectedIndex(0);
        raceIdComboBox.setSelectedIndex(0);
        statusBarLabel.setText("");
        setActionButtons(true, true, false, false);
        this.setTitle("Register a Participant");
    }

    public boolean validateEntries() {
        boolean valid = true;

        if ((ssnTextField.getText().trim().length() > 35)
                || (ssnTextField.getText().trim().equals("") == true)) {
            valid = false;
            statusBarLabel.setText(
                    " Error: Maximum of 35 Characters are allowed for Social Security Number.");
            Toolkit.getDefaultToolkit().beep();
        } else if (nameTextField.getText().trim().length() > 100) {
            valid = false;
            statusBarLabel.setText(
                    " Error: Maximum of 100 Characters are allowed for First Name.");
            Toolkit.getDefaultToolkit().beep();
        } else if (surnameTextField.getText().trim().length() > 150) {
            valid = false;
            statusBarLabel.setText(
                    " Error: Maximum of 150 Characters are allowed for Surname.");
            Toolkit.getDefaultToolkit().beep();
        } else if (nicknameTextField.getText().trim().length() > 100) {
            valid = false;
            statusBarLabel.setText(
                    " Error: Maximum of 100 Characters are allowed for Nickname.");
            Toolkit.getDefaultToolkit().beep();
        } else if (reg.validateDate(birthDateTextField.getText().trim(), dateString) == false) {
            valid = false;
            statusBarLabel.setText(
                    " Error: Date of Birth must be in dd/mm/yyyy format and not Today's Date");
            Toolkit.getDefaultToolkit().beep();
        } else if ((ageTextField.getText().trim().equals("") == false) && (reg.isInteger(ageTextField.getText().trim()) == false)) {
            valid = false;
            statusBarLabel.setText(
                    " Error: Age must be an Integer Number");
            Toolkit.getDefaultToolkit().beep();
        } else if (prTextField.getText().trim().length() > 200) {
            valid = false;
            statusBarLabel.setText(
                    " Error: Maximum of 20 Characters are allowed for PR(Personal Running Record).");
            Toolkit.getDefaultToolkit().beep();
        } else if (address1TextField.getText().trim().length() > 200) {
            valid = false;
            statusBarLabel.setText(
                    " Error: Maximum of 200 Characters are allowed for Address 1.");
            Toolkit.getDefaultToolkit().beep();
        } else if (address2TextField.getText().trim().length() > 200) {
            valid = false;
            statusBarLabel.setText(
                    " Error: Maximum of 200 Characters are allowed for Address 2.");
            Toolkit.getDefaultToolkit().beep();
        } else if (cityTextField.getText().trim().length() > 100) {
            valid = false;
            statusBarLabel.setText(
                    " Error: Maximum of 100 Characters are allowed for City.");
            Toolkit.getDefaultToolkit().beep();
        } else if (stateTextField.getText().trim().length() > 100) {
            valid = false;
            statusBarLabel.setText(
                    " Error: Maximum of 100 Characters are allowed for State.");
            Toolkit.getDefaultToolkit().beep();
        } else if (zipTextField.getText().trim().length() > 25) {
            valid = false;
            statusBarLabel.setText(
                    " Error: Maximum of 25 Characters are allowed for Zip Code.");
            Toolkit.getDefaultToolkit().beep();
        } else if (countryTextField.getText().trim().length() > 100) {
            valid = false;
            statusBarLabel.setText(
                    " Error: Maximum of 100 Characters are allowed for Country.");
            Toolkit.getDefaultToolkit().beep();
        } else if (emailTextField.getText().trim().length() > 200) {
            valid = false;
            statusBarLabel.setText(
                    " Error: Maximum of 100 Characters are allowed for Email.");
            Toolkit.getDefaultToolkit().beep();
        } else if (mobileTextField.getText().trim().length() > 35) {
            valid = false;
            statusBarLabel.setText(
                    " Error: Maximum of 35 Characters are allowed for Mobile.");
            Toolkit.getDefaultToolkit().beep();
        } else if (phoneTextField.getText().trim().length() > 50) {
            valid = false;
            statusBarLabel.setText(
                    " Error: Maximum of 50 Characters are allowed for Phone.");
            Toolkit.getDefaultToolkit().beep();
        } else if (emergPhoneTextField.getText().trim().length() > 50) {
            valid = false;
            statusBarLabel.setText(
                    " Error: Maximum of 100 Characters are allowed for Emergency Phone.");
            Toolkit.getDefaultToolkit().beep();
        }
        return valid;
    }

    public void allocateRecord() {
        person = new Participant();
        person.setSsn(ssnTextField.getText().trim());
        person.setName(nameTextField.getText().trim());
        person.setSurname(surnameTextField.getText().trim());
        person.setNickname(nicknameTextField.getText().trim());
        person.setBirthDate(birthDateTextField.getText().trim());
        if (ageTextField.getText().trim().equals("") == false) {
            person.setAge(Integer.parseInt(ageTextField.getText().trim()));
        }
        person.setPr(prTextField.getText().trim());
        person.setAddress1(address1TextField.getText().trim());
        person.setAddress2(address2TextField.getText().trim());
        person.setCity(cityTextField.getText().trim());
        person.setState(stateTextField.getText().trim());
        person.setZip(zipTextField.getText().trim());
        person.setCountry(countryTextField.getText().trim());
        person.setGender((String) genderComboBox.getSelectedItem());
        person.setEmail(emailTextField.getText().trim());
        person.setPhone(phoneTextField.getText().trim());
        person.setEmergPhone(emergPhoneTextField.getText().trim());
        person.setMobile(mobileTextField.getText().trim());
        person.setRaceId(Integer.parseInt((String) raceIdComboBox.getSelectedItem()));
        person.setRaceType((String) raceTypeComboBox.getSelectedItem());

    }

    public void saveButton_actionPerformed(ActionEvent e) {
        boolean valid = false;
        boolean saved = false;
        valid = validateEntries();
        if (valid == true) {
            allocateRecord();
            saved = reg.registerParticipant(person);
            if (saved == true) {
                clear();
                statusBarLabel.setText(person.getSsn() + " Social Security Number has been registered successfully.");
            } else {
                statusBarLabel.setText("ERROR: " + person.getSsn() + " has not been Saved");
            }
        }
    }

    void birthDateTextField_focusGained(FocusEvent e) {
        statusBarLabel.setText("Birth Date must be in DD/MM/YYYY format");
        ageFlag = true;
    }

    void prTextField_focusGained(FocusEvent e) {
        statusBarLabel.setText("Enter Personal Running Record (PR)");
    }

    void prTextField_focusLost(FocusEvent e) {
        statusBarLabel.setText("");
    }

    void birthDateTextField_focusLost(FocusEvent e) {
        statusBarLabel.setText("");
        if (reg.validateDate(birthDateTextField.getText().trim(), dateString) == true) {
            ageTextField.setText(String.valueOf(person.calculateAge(reg.getBirthYear())));
        }

    }

    void ssnTextField_focusGained(FocusEvent e) {
        ssnFocus = true;
    }

    void ssnTextField_keyTyped(KeyEvent e) {
        ssnTyped = true;
    }

    void ssnTextField_focusLost(FocusEvent e) {
        updatePerson = new Participant();
        if ((ssnFocus == true) && (ssnTyped == true)) {
            updatePerson = reg.validateSSN(ssnTextField.getText().trim());
            if (((updatePerson.getSsn()).equals("")) == false) {
                dupSSN = ssnTextField.getText().trim();
                statusBarLabel.setText("Duplicate Entry, " + dupSSN + " Social Security Number is already Registered.");
                displayRecord(updatePerson);
                setActionButtons(false, true, true, true);
                this.setTitle("Participant");
            }
        }
        ssnFocus = false;
        ssnTyped = false;

    }

    public void displayRecord(Participant aPerson) {
        ssnTextField.setText(aPerson.getSsn());
        nameTextField.setText(aPerson.getName());
        surnameTextField.setText(aPerson.getSurname());
        nicknameTextField.setText(aPerson.getNickname());
        birthDateTextField.setText(aPerson.getBirthDate());
        ageTextField.setText(String.valueOf(aPerson.getAge()));
        prTextField.setText(aPerson.getPr());
        address1TextField.setText(aPerson.getAddress1());
        address2TextField.setText(aPerson.getAddress2());
        cityTextField.setText(aPerson.getCity());
        stateTextField.setText(aPerson.getState());
        zipTextField.setText(aPerson.getZip());
        countryTextField.setText(aPerson.getCountry());
        genderComboBox.setSelectedItem(aPerson.getGender());
        emailTextField.setText(aPerson.getEmail());
        phoneTextField.setText(aPerson.getPhone());
        emergPhoneTextField.setText(aPerson.getEmergPhone());
        mobileTextField.setText(aPerson.getMobile());
        raceIdComboBox.setSelectedItem(String.valueOf(aPerson.getRaceId()));
        raceTypeComboBox.setSelectedItem(aPerson.getRaceType());
    }

    void deleteButton_actionPerformed(ActionEvent e) {
        boolean delFlag = false;
        Object[] options = {"Yes", "No", "Cancel"};
        this.setTitle("Delete A Participant");
        int response = JOptionPane.showOptionDialog(this,
                "Are you sure you want to permanently delete this Participant?",
                "Confirm Delete",
                JOptionPane.YES_NO_CANCEL_OPTION,
                JOptionPane.WARNING_MESSAGE,
                null,
                options,
                options[2]);
        if (response == 0) {
            delFlag = reg.deleteParticipant(updatePerson.getId(), updatePerson.getSsn());
        }
        if (delFlag == true) {
            statusBarLabel.setText(updatePerson.getSsn() + " has been Removed from Database.");
            clear();
        } else {
            boolean flag = reg.isSsnInWinner();
            if (flag == true) {
                statusBarLabel.setText("ERROR: There is a Winner with this Social Security Number, Delete the Winner First.");
            } else {
                statusBarLabel.setText("ERROR: " + updatePerson.getSsn() + " has not removed from Database");
            }

        }
    }

    void updateButton_actionPerformed(ActionEvent e) {
        boolean valid = false;
        boolean updated = false;
        valid = validateEntries();
        if (valid == true) {
            allocateRecord();
            person.setId(updatePerson.getId());
            updated = reg.updateParticipant(person);
            if (updated == true) {
                clear();
                statusBarLabel.setText(person.getSsn() + " Social Security Number has been updated successfully.");
            } else {
                statusBarLabel.setText("ERROR: " + person.getSsn() + " Update has not been Saved");


            }
        }
    }
}

class RegisterUI_clearButton_actionAdapter
        implements java.awt.event.ActionListener {

    RegisterUI adaptee;

    RegisterUI_clearButton_actionAdapter(RegisterUI adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.clearButton_actionPerformed(e);
    }
}

class RegisterUI_saveButton_actionAdapter
        implements java.awt.event.ActionListener {

    RegisterUI adaptee;

    RegisterUI_saveButton_actionAdapter(RegisterUI adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.saveButton_actionPerformed(e);
    }
}

class RegisterUI_birthDateTextField_focusAdapter
        extends java.awt.event.FocusAdapter {

    RegisterUI adaptee;

    RegisterUI_birthDateTextField_focusAdapter(RegisterUI adaptee) {
        this.adaptee = adaptee;
    }

    public void focusGained(FocusEvent e) {
        adaptee.birthDateTextField_focusGained(e);
    }

    public void focusLost(FocusEvent e) {
        adaptee.birthDateTextField_focusLost(e);
    }
}

class RegisterUI_prTextField_focusAdapter
        extends java.awt.event.FocusAdapter {

    RegisterUI adaptee;

    RegisterUI_prTextField_focusAdapter(RegisterUI adaptee) {
        this.adaptee = adaptee;
    }

    public void focusGained(FocusEvent e) {
        adaptee.prTextField_focusGained(e);
    }

    public void focusLost(FocusEvent e) {
        adaptee.prTextField_focusLost(e);
    }
}

class RegisterUI_ssnTextField_focusAdapter extends java.awt.event.FocusAdapter {

    RegisterUI adaptee;

    RegisterUI_ssnTextField_focusAdapter(RegisterUI adaptee) {
        this.adaptee = adaptee;
    }

    public void focusGained(FocusEvent e) {
        adaptee.ssnTextField_focusGained(e);
    }

    public void focusLost(FocusEvent e) {
        adaptee.ssnTextField_focusLost(e);
    }
}

class RegisterUI_ssnTextField_keyAdapter extends java.awt.event.KeyAdapter {

    RegisterUI adaptee;

    RegisterUI_ssnTextField_keyAdapter(RegisterUI adaptee) {
        this.adaptee = adaptee;
    }

    public void keyTyped(KeyEvent e) {
        adaptee.ssnTextField_keyTyped(e);
    }
}

class RegisterUI_deleteButton_actionAdapter implements java.awt.event.ActionListener {

    RegisterUI adaptee;

    RegisterUI_deleteButton_actionAdapter(RegisterUI adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.deleteButton_actionPerformed(e);
    }
}

class RegisterUI_updateButton_actionAdapter implements java.awt.event.ActionListener {

    RegisterUI adaptee;

    RegisterUI_updateButton_actionAdapter(RegisterUI adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.updateButton_actionPerformed(e);
    }
}
