/*
 Class: Registration
 Author: Shahrzad Jahangirian
 Date: March 24, 2014
 Update Date: May 2, 2014
 Description: A problem domain class for processing Registration
 */
package PDpkg;
import java.util.*;
import java.text.*;
import PDpkg.Participant;
import DBpkg.ParticipantDB;

public class Registration{

 private ParticipantDB participantDb = new ParticipantDB();
 private int[] birthDate2 = new int[3];

  public Registration(){

  }
  
  public boolean isParticipantEmpty(){
      return participantDb.isParticipantEmpty();
  }

  public boolean validateDate(String bDate, String today) {
    boolean valid = true;
    try {
      String[] result = bDate.split("\\/");
      birthDate2[0] = Integer.parseInt(result[2]);
      birthDate2[1] = Integer.parseInt(result[1]);
      birthDate2[2] = Integer.parseInt(result[0]);
      if (bDate.equals(today) == true) {
        valid = false;
      }
    }
    catch (Exception ex) {
      valid = false;
    }
    return valid;
  }

  public int getBirthYear(){
    return birthDate2[0];
  }

  public boolean isInteger(String str) {
    boolean valid = false;
    try {
      Integer.parseInt(str);
      valid = true;
    }
    catch (Exception e) {
      valid = false;
    }
    return valid;
  }
  
  public Participant validateSSN(String ssnId){
      Participant person = new Participant();
      boolean duplicateSSN = false;
      duplicateSSN = participantDb.isSsnDuplicate(ssnId);
      if (duplicateSSN == true){    
          person = participantDb.getRecord();
      }
      return person;
  }

  public boolean registerParticipant(Participant person){
    boolean ok = false;
    person.setId(participantDb.getNextId());
    ok = participantDb.saveParticipant(person);
    return ok;
  }
  
  public boolean updateParticipant(Participant person){
    boolean ok = false;    
    ok = participantDb.updateParticipant(person);
    return ok;
  }
  
  public boolean deleteParticipant(int participantId, String ssn){
    boolean ok = false;    
    ok = participantDb.deleteParticipant(participantId,ssn);
    return ok;
  }  
  
  public boolean isSsnInWinner(){
      return participantDb.isSsnInWinner();
  }
}
