/*
 Class: Winner
 Author: Shahrzad Jahangirian
 Date: June 21, 2014
 Description: A problem domain class for processing Bolder Race Winners
 */
package PDpkg;
import java.util.*;
import java.text.*;
import PDpkg.WinnerInfo;
import DBpkg.ParticipantDB;
import DBpkg.RaceDB;
import DBpkg.WinnerDB;

public class Winner{

 private WinnerDB winnerDb = new WinnerDB();
 private RaceDB racedb = new RaceDB();
 private ParticipantDB playerdb = new ParticipantDB();

  public Winner(){

  }
  
    public WinnerInfo isDuplicateEntry(int raceId, String ssn){
      WinnerInfo winnerRecord = new WinnerInfo();
      boolean duplicate = false;
      duplicate = winnerDb.isWinnerDuplicate(raceId,ssn);
      if (duplicate == true){    
          winnerRecord = winnerDb.getRecord();
      } 
      return winnerRecord;
  }

  
  public boolean isRaceId(int raceId){  
      return racedb.isRaceIdExist(raceId);
  }
  
  public boolean isParticipantSSN(String ssnId){  
      return playerdb.isSsnExist(ssnId);
  }

  public boolean addWinner(WinnerInfo winnerRecord){
    boolean ok = false;   
    ok = winnerDb.saveWinner(winnerRecord);
    return ok;
  }
  
  public boolean updateWinner(WinnerInfo winnerRecord){
    boolean ok = false;    
    ok = winnerDb.updateWinner(winnerRecord);
    return ok;
  }
  
  public boolean deleteWinner(int raceId, String ssn){
    boolean ok = false;    
    ok = winnerDb.deleteWinner(raceId, ssn);
    return ok;
  }  
  
    public boolean isWinnerEmpty(){
      return winnerDb.isWinnerEmpty();
  }
}
